#include "DualPointCrossover.hh"


int DualPointCrossover::matesExpected() {
    return 2;
}

ArrayList<Solution> *DualPointCrossover::cross(ArrayList<Solution> *mates) {

    if (mates->length() != 2) {
        cout << "mates must be two, in dual point crossover" << endl;
        exit(1);
    }

    IntArraySolution *solution0 = (IntArraySolution*)mates->get(0);
    IntArraySolution *solution1 = (IntArraySolution*)mates->get(1);

    IntArraySolution *child0 = new IntArraySolution();
    IntArraySolution *child1 = new IntArraySolution();


    int size = IntArraySolution::getSize();
    int x = Random::getInstance()->getInt(size);
    int y = Random::getInstance()->getInt(size);

    if (y < x) {
        int temp = x;
        x = y;
        y = temp;
    }

    for (int i = 0; i < size; i++) {
        if (i < x) {

            child0->set(i, solution0->get(i));
            child1->set(i, solution1->get(i));

        } else if (x <= i && i < y){

            child0->set(i, solution1->get(i));
            child1->set(i, solution0->get(i));

        } else {
            child0->set(i, solution0->get(i));
            child1->set(i, solution1->get(i));
        }
    }


    ArrayList<Solution> *childs = new ArrayList<Solution>(false);
    childs->add(child0);
    childs->add(child1);

    return childs;
}
